<i18n>
{
  "fr": {
    "label-1": "Type de véhicule",
    "label-2": "Part de l'empreinte véhicule"
  },
  "en": {
    "label-1": "Type of vehicle",
    "label-2": "Share of the vehicle footprint"
  }
}
</i18n>

<template>
  <div>
    <highcharts :options="emissionOptions"></highcharts>
    <br />
    <b-table
      :striped="true"
      :narrowed="true"
      :hoverable="true"
      :data="emissionsPerTypes"
    >
      <b-table-column field= "type" :label="$t('label-1')" v-slot="props">
        {{ props.row.type }}
      </b-table-column>
      <b-table-column field= "intensity" numeric :label="$t('emissions.t.co2e.short')" v-slot="props">
        {{ Math.round(props.row.intensity) | splitNumberTons }} &plusmn; {{ Math.round(props.row.uncertainty) | splitNumberTons }}
      </b-table-column>
      <b-table-column numeric :label="$t('label-2')" v-slot="props">
        {{ Math.round(props.row.intensity / results.intensity.intensity * 100 ) }} %
      </b-table-column>
    </b-table>
  </div>
</template>

<script>
import '@/plugins/highcharts.js'

export default {
  name: 'PlotsVehicles',
  data () {
    const component = this
    return {
      emissionOptions: {
        chart: {
          type: 'pie'
        },
        title: {
          verticalAlign: 'middle',
          floating: true,
          text: ''
        },
        plotOptions: {
          pie: {
            innerSize: '60%',
            allowPointSelect: true,
            cursor: 'pointer',
            dataLabels: {
              enabled: true,
              formatter () {
                return (
                  `<b>${this.point.name}:</b> ${component.$options.filters.splitNumberTons(this.y)} ${component.$t('t.co2e')}`
                )
              }
            },
            showInLegend: true
          }
        },
        credits: {
          enabled: false
        },
        legend: {
          enabled: false
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: ['downloadPNG', 'downloadJPEG', 'downloadPDF', 'downloadSVG']
            }
          },
          chartOptions: {
            chart: {
              width: 750,
              height: 400
            }
          }
        },
        series: [{
          name: this.$t('carbon.footprint'),
          colorByPoint: true,
          data: []
        }],
        tooltip: {
          pointFormatter () {
            return (
              `<b>${component.$options.filters.splitNumberTons(this.y)} ${component.$t('t.co2e')}</b>`
            )
          }
        }
      }
    }
  },
  computed: {
    results: function () {
      return this.$store.getters['vehicles/results']
    },
    emissionsPerTypes: function () {
      let emissionsPerTypes = []
      for (let result of this.results.meta) {
        let oindex = emissionsPerTypes.findIndex(obj => obj.type === this.$t(result.type))
        if (oindex < 0) {
          emissionsPerTypes.push({
            'type': this.$t(result.type),
            'intensity': result.intensity.intensity,
            'uncertainty': result.intensity.uncertainty
          })
        } else {
          emissionsPerTypes[oindex].intensity += result.intensity.intensity
          emissionsPerTypes[oindex].uncertainty += result.intensity.uncertainty
        }
      }
      return emissionsPerTypes
    }
  },
  methods: {
    process: function () {
      if (this.$store.getters['vehicles/computed']) {
        for (let objectType of this.emissionsPerTypes) {
          this.emissionOptions.series[0].data.push({
            name: objectType.type,
            y: Math.round(objectType.intensity)
          })
        }
      }
    }
  },
  mounted () {
    if (!this.$store.getters['vehicles/computed']) {
      this.$store.dispatch('vehicles/compute')
    }
    this.process()
    this.emissionOptions.title.text = '<strong>' + this.$options.filters.splitNumberTons(Math.round(this.results.intensity.intensity)) + ' ' + this.$t('t.co2e') + ' </strong>'
  }
}
</script>

<style>
.table td {
  vertical-align: middle !important;
}
</style>
